package com.example.stimulusStrategy;

import android.app.Notification;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.IBinder;
import android.support.annotation.Nullable;
import android.util.Log;
import android.widget.Toast;

import com.example.pharmacy.frontEnd.R;
import com.example.stimulus.SedentaryStimulus;


/**
 * Created by pharmacy on 09/01/2018.
 */

public class Accelerometer extends Service implements StimulusStrategy, SensorEventListener {

    private SensorManager mSensorManager;
    private Sensor accl;
   //private Context context;


    @Override
    public int onStartCommand(Intent intent, int flags, int startId){
        Log.d("ACCEL", "CREATED ACCEL");
        mSensorManager = (SensorManager) this.getSystemService(Context.SENSOR_SERVICE);
        mSensorManager.registerListener(this, mSensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER), 60000000);
        //Parameters to be set here such as delay etc.
        //Does data streaming/listening need to be set up? If so here
        return START_STICKY;
    }

   /* public Accelerometer(Context context){
        this.context = context;

    }*/

    public void monitor() {

        Log.d("ACCEL", "MONITORING");
        Toast saved = Toast.makeText(this, R.string.motion,Toast.LENGTH_LONG);
        saved.show();
        mSensorManager.unregisterListener(this);
        Intent i = new Intent(this, com.example.notification.Notification.class);
        this.sendBroadcast(i);
        stopSelf();
    }


    @Override
    public void onSensorChanged(SensorEvent event) {

        float[] gravity = new float[3];
        float[] linearAcc = new float[3];
int moved = 0;

        final float alpha = (float) 0.8;

        gravity[0] = alpha * gravity[0] + (1 - alpha) * event.values[0];
        gravity[1] = alpha * gravity[1] + (1 - alpha) * event.values[1];
        gravity[2] = alpha * gravity[2] + (1 - alpha) * event.values[2];

        linearAcc[0] = event.values[0] - gravity[0];
        linearAcc[1] = event.values[1] - gravity[1];
        linearAcc[2] = event.values[2] - gravity[2];
        Log.d("ACCEL", "SENSOR EVENT");
        for(int i = 0; i < 3; i++){
            if(linearAcc[i] > 1){
              moved++;
            }
        }
        if(moved >= 2) {
            monitor();
        }
    }

    @Override
    public void onAccuracyChanged(Sensor sensor, int i) {

    }


    @Nullable
    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }
}
